import discord
from discord import option
from discord.ext import commands
import core_utils


class AnimeGirls(commands.Cog):
    def __init__(self, bot):
        self.bot: commands.Bot = bot

    @commands.slash_command(
        guild_ids=None,
        name="yeet",
        description="Posts a gif of an anime girl yeeting",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def yeet(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="yeet")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="cuddle",
        description="Posts a gif of an anime girl cuddleing",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def cuddle(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="cuddle")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="awoo",
        description="Posts a gif of a dog/anime girl",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def awoo(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="awoo")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="bonk",
        description="Posts a gif of an anime bonking someone on the head",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def bonk(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="bonk")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="glomp",
        description="Posts a gif of an aggressive hug",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def glomp(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="glomp")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="pout",
        description="Posts a gif of an anime girl pouting",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def pout(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="blush")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="waifu",
        description="Posts a gif of an anime girl",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def waifu(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="waifu")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="neko",
        description="Posts a gif of a cat/anime girl",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def neko(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="neko")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="bully",
        description="Posts a gif of an anime girl bullying someone",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def bully(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="bully")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="cry",
        description="Posts a gif of an anime girl crying",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def cry(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="cry")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="hug",
        description="Posts a gif of an anime girl huging",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def hug(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="hug")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="kiss",
        description="Posts a gif of an anime girl kissing",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def kiss(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="kiss")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="lick",
        description="Posts a gif of an anime girl licking",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def lick(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="lick")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="pat",
        description="Posts a gif of an anime girl pating someone on the head",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def pat(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="pat")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="smug",
        description="Posts a gif of an anime girl being smug",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def smug(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="smug")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="highfive",
        description="Posts a gif of an anime girl highfiveing",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def highfive(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="highfive")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="nom",
        description="Posts a gif of an anime girl eating",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def nom(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="nom")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="bite",
        description="Posts a gif of an anime girl biting someone",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def bite(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="bite")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="slap",
        description="Posts a gif of an anime girl slapping",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def slap(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="slap")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="wink",
        description="Posts a gif of an anime girl winking",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def wink(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="wink")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="poke",
        description="Posts a gif of an anime girl pokeing",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def poke(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="poke")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="dance",
        description="Posts a gif of an anime girl dancing",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def dance(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="dance")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="cringe",
        description="Posts a gif of an anime girl cringeing",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def cringe(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="cringe")
            )
        )

    @commands.slash_command(
        guild_ids=None,
        name="blush",
        description="Posts a gif of an anime girl blushing",
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def blush(self, ctx: discord.ApplicationContext):
        await ctx.respond(
            embed=core_utils.generate_embed(
                embed_url=core_utils.waifu_pics(endpoint="blush")
            )
        )

    @commands.slash_command(guild_ids=None, name="owo", description="owo-afies text")
    @option(
        name="input_string",
        description="The text you want owo-afied",
        required=True,
        contexts={
            discord.InteractionContextType.guild,
            discord.InteractionContextType.bot_dm,
            discord.InteractionContextType.private_channel,
        },
        integration_types={
            discord.IntegrationType.guild_install,
            discord.IntegrationType.user_install,
        },
    )
    async def owo(self, ctx: discord.ApplicationContext, input_string: str):
        from owotext import OwO

        uwu = OwO()
        await ctx.respond(uwu.whatsthis(input_string))


def setup(bot):
    bot.add_cog(AnimeGirls(bot))
